"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
const labels = new Map([['1c', '1С:Enterprise 8'], ['abap', 'ABAP'], ['actionscript2', 'ActionScript 2'], ['actionscript3', 'ActionScript 3'], ['asdoc', 'ASDoc'], ['flex-config', 'Flex Config'], ['ada', 'Ada'], ['angularjs', 'AngularJS'], ['ansible', 'Ansible'], ['apache', 'Apache Config'], ['apache-modperl', 'Apache mod_perl Config'], ['apiblueprint', 'API Blueprint'], ['mson', 'MSON'], ['applescript', 'AppleScript'], ['arduino', 'Arduino'], ['asciidoc', 'AsciiDoc'], ['asp', 'ASP'], ['asp-html', 'ASP HTML'], ['ashx', 'ASHX Handler'], ['aspx', 'ASPX Web Forms/Controls'], ['asm-x86', 'x86 Assembly'], ['asm-x86-64', 'x86-64 Assembly'], ['asm-mips', 'MIPS Assembly'], ['asm-arm', 'ARM Assembly'], ['autohotkey', 'AutoHotkey'], ['autoitv3', 'AutoIt v3'], ['awk', 'AWK'], ['bash', 'Bash'], ['shell-script', 'Shell Script'], ['shell-script-session', 'Shell Script Session'], ['batchfile', 'Batch File'], ['bison', 'Bison'], ['blade', 'Blade'], ['bolt', 'Bolt'], ['brainfuck', 'Brainfuck'], ['brightscript', 'BrightScript'], ['c', 'C'], ['cpp', 'C++'], ['cfml', 'CFML'], ['cfscript', 'CFScript'], ['cfml-html', 'CFML HTML'], ['chef', 'Chef'], ['cisco', 'Cisco IOS'], ['clips', 'CLIPS'], ['clojure', 'Clojure'], ['coffeescript', 'CoffeeScript'], ['litcoffee', 'Literate CoffeeScript'], ['cobol', 'Cobol'], ['jcl', 'JCL'], ['cmake-listfile', 'CMake Listfile'], ['cmake-cache', 'CMake Cache'], ['cmake-c', 'CMake template C'], ['cmake-cpp', 'CMake template C++'], ['cmake-python', 'CMake template Python'], ['cmake-shellscript', 'CMake template Shell Script'], ['cmake-batchfile', 'CMake template Batchfile'], ['cmake-cmake', 'CMake template Cmake'], ['common-lisp', 'Common Lisp'], ['config', 'Generic Config'], ['crontab', 'crontab'], ['crystal', 'Crystal'], ['ecr', 'ECR'], ['csharp', 'C#'], ['csharp-nant', 'NAnt'], ['csharp-cake', 'Cake'], ['csharp-csx', 'CSX'], ['cshtml', 'ASP.NET Razor'], ['css', 'CSS'], ['csv', 'CSV'], ['csv-semicolon', 'CSV'], ['cuda', 'CUDA'], ['d', 'D'], ['dart', 'Dart'], ['dart-yaml', 'Dart YAML'], ['debian-control', 'Debian Package Control'], ['debian-rules', 'Debian Package Rules'], ['diff', 'diff'], ['django-template', 'Django Template'], ['dockerfile', 'Dockerfile'], ['dockerignore', '.dockerignore'], ['dot', 'DOT'], ['dotfiles', '.dotfiles'], ['doxyfile', 'Doxyfile'], ['dustjs', 'Dust.js'], ['ejs', 'EJS'], ['elixir', 'Elixir'], ['eex', 'EEx'], ['eex-html', 'EEx HTML'], ['eex-xml', 'EEx XML'], ['elm', 'Elm'], ['elmx', 'Elmx'], ['emacs-lisp', 'Emacs Lisp'], ['erlang', 'Erlang'], ['erlang-html', 'Erlang YAWS eHTML'], ['expressionengine', 'ExpressionEngine'], ['fish', 'fish'], ['fortran-fixed', 'Fortran Fixed Form'], ['fortran-free', 'Fortran Free Form'], ['fortran-modern', 'Fortran Modern'], ['fortran-preprocessor', 'Fortran Preprocessor'], ['fortran-punchcard', 'Fortran Punchcard'], ['freemarker', 'FreeMarker'], ['fsharp', 'F#'], ['gdscript', 'GDScript'], ['gettext', 'gettext'], ['gherkin', 'Gherkin'], ['gfm', 'GFM'], ['git-commit', 'Git Commit'], ['git-config', 'Git Config'], ['git-rebase', 'Git Rebase'], ['gitignore', '.gitignore'], ['glsl', 'GLSL'], ['go', 'Go'], ['go-template', 'Go Template'], ['go-template-html', 'Go Template HTML'], ['gradle', 'Gradle'], ['graphql', 'GraphQL'], ['groovy', 'Groovy'], ['haml', 'Haml'], ['haml-coffee', 'Haml CoffeeScript'], ['handlebars', 'Handlebars'], ['haproxy', 'HAProxy'], ['haskell', 'Haskell'], ['lithaskell', 'Literate Haskell'], ['cabal', 'Cabal'], ['haxe', 'Haxe'], ['haxe-hxml', 'Haxe HXML'], ['hosts', 'Hosts'], ['hql', 'HQL'], ['htaccess', '.htaccess'], ['html', 'HTML'], ['hyperlink', 'Hyperlink'], ['ignore', '.ignore'], ['slugignore', '.slugignore'], ['hignore', '.hignore'], ['ini', 'INI'], ['jade', 'Jade'], ['pyjade', 'PyJade'], ['java', 'Java'], ['java-junit', 'JUnit'], ['java-jsp', 'JSP'], ['javascript', 'JavaScript'], ['jinja2', 'Jinja2'], ['jinja2-html', 'Jinja2 HTML'], ['jinja2-python', 'Jinja2 Python'], ['jinja2-conf', 'Jinja2 Conf'], ['jinja2-markdown', 'Jinja2 Markdown'], ['jinja2-shell-script', 'Jinja2 Shell Script'], ['jinja2-xml', 'Jinja2 XML'], ['jinja2-yaml', 'Jinja2 YAML'], ['json', 'JSON'], ['julia', 'Julia'], ['julia-console', 'Julia Console'], ['junos', 'Juniper Junos'], ['kivy', 'Kivy'], ['kotlin', 'Kotlin'], ['latex', 'LaTeX'], ['tex', 'TeX'], ['latex-memoir', 'LaTeX Memoir'], ['latex-log', 'LaTeX Log'], ['latex-beamer', 'LaTeX Beamer'], ['bibtex', 'BibTeX'], ['leaf', 'Leaf'], ['less', 'Less'], ['liquid-html', 'Liquid HTML'], ['liquid-scss', 'Liquid SCSS'], ['lisp', 'Lisp'], ['livescript', 'LiveScript'], ['llvm', 'LLVM'], ['log', 'Log'], ['logstash', 'Logstash'], ['lua', 'Lua'], ['make', 'Makefile'], ['mako', 'Mako'], ['markdown', 'Markdown'], ['marko', 'Marko'], ['mathematica', 'Mathematica'], ['matlab', 'MATLAB'], ['octave', 'Octave'], ['mediawiki', 'MediaWiki'], ['mjml', 'MJML'], ['modelica', 'Modelica'], ['modelicascript', 'ModelicaScript'], ['mongodb-js', 'MongoDB JavaScript'], ['mustache', 'Mustache'], ['mustache-sql', 'Mustache SQL'], ['mxml', 'MXML'], ['nagios', 'Nagios'], ['nftables', 'nftables'], ['nginx', 'nginx'], ['nsis', 'NSIS'], ['nlf', 'NLF'], ['nunjucks', 'Nunjucks'], ['nunjucks-html', 'Nunjucks HTML'], ['objetive-c', 'Objetive-C'], ['objetive-cpp', 'Objetive-C++'], ['ocaml', 'OCaml'], ['ocamllex', 'ocamllex'], ['menhir', 'Menhir'], ['camlp4', 'Camlp4'], ['opencl', 'OpenCL'], ['openscad', 'OpenSCAD'], ['pascal', 'Pascal'], ['patch', 'Patch File'], ['pegjs', 'PEG.js'], ['pegcoffee', 'PEG.js CoffeeScript'], ['perl', 'Perl'], ['perl6', 'Perl 6'], ['php', 'PHP'], ['pl-pgsql', 'PL/PgSQL'], ['pl-sql', 'PL/SQL'], ['plantuml', 'PlantUML'], ['pony', 'Pony'], ['postcss', 'PostCSS'], ['sugarss', 'SugarSS'], ['powershell', 'PowerShell'], ['processing', 'Processing'], ['property-list', 'Property List'], ['property-list-old', 'Property List Old-Style'], ['prolog', 'Prolog'], ['protobuf', 'Protocol Buffers'], ['pug', 'Pug'], ['puppet', 'Puppet'], ['purescript', 'PureScript'], ['python', 'Python'], ['python-console', 'Python Console'], ['python-traceback', 'Python Traceback'], ['qml', 'QML'], ['qtpro', 'QtPro'], ['r', 'R'], ['r-documentation', 'R Documentation'], ['racket', 'Racket'], ['scribble', 'Scribble'], ['rdf-turtle', 'RDF Turtle'], ['rdf-n-triples', 'RDF N-Triples'], ['rdf-trig', 'RDF TriG'], ['jsx', 'JSX'], ['cjsx', 'CJSX'], ['restructuredtext', 'reStructuredText'], ['review', 'Re:VIEW'], ['riot', 'Riot'], ['robot', 'Robot Framework'], ['rspec', 'RSpec'], ['ruby', 'Ruby'], ['erb', 'ERB'], ['erb-js', 'ERB JavaScript'], ['erb-sql', 'ERB SQL'], ['ruby-on-rails', 'Ruby on Rails'], ['rust', 'Rust'], ['salt', 'Salt'], ['sass', 'Sass'], ['scss', 'Scss'], ['scala', 'Scala'], ['scheme', 'Scheme'], ['serpent', 'Serpent'], ['serpent-console', 'Serpent Console'], ['serpent-trackback', 'Serpent Traceback'], ['solidity', 'Solidity'], ['shaderlab', 'ShaderLab'], ['spacebars', 'Spacebars'], ['slim', 'Slim'], ['smarty', 'Smarty'], ['sml', 'Standard ML'], ['sml-mlb', 'Standard ML MLB'], ['sml-cm', 'Standard ML CM'], ['soy', 'Closure Templates (Soy)'], ['sql', 'SQL'], ['stan', 'Stan'], ['stylus', 'Stylus'], ['svg', 'SVG'], ['swift', 'Swift'], ['swig', 'Swig'], ['systemd', 'systemd'], ['tcl', 'Tcl'], ['tcl-html', 'Tcl HTML'], ['terraform', 'Terraform'], ['hil', 'HIL'], ['text', 'Plain Text'], ['textile', 'Textile'], ['todo', 'TODO'], ['toml', 'TOML'], ['twig', 'Twig'], ['twig-html', 'Twig HTML'], ['twig-js', 'Twig JavaScript'], ['twig-json', 'Twig JSON'], ['twig-css', 'Twig CSS'], ['twig-xml', 'Twig XML'], ['twig-yaml', 'Twig YAML'], ['typescript', 'TypeScript'], ['typescript-jsx', 'TypeScript JSX'], ['uno', 'Uno'], ['vala', 'Vala'], ['vb-net', 'Visual Basic .NET'], ['vbscript', 'VBScript'], ['velocity', 'Apache Velocity'], ['velocity-html', 'Apache Velocity HTML'], ['verilog', 'Verilog'], ['vhdl', 'VHDL'], ['viml', 'VimL'], ['vuejs', 'Vue.js'], ['xml', 'XML'], ['xsl', 'XSL'], ['yaml', 'YAML']]);
var _default = labels;
exports.default = _default;